// As AUI does not currently provide the capability we need for a banner announcing upcoming changes we have built this
// It is not intended to live a long life.

require( [
    'ajs',
    'jquery',
    'confluence/templates'
], function(
    AJS,
    $,
    Templates
) {
    AJS.toInit (function() {
        var PLUGIN_KEY = "com.atlassian.confluence.plugins.confluence-collaborative-editor-plugin";
        var FEATURE_DISCOVERY_ID = "coming-soon-banner";
        var BANNER_LINK = 'class="collaborative-editing-banner-doc-link" href="https://confluence.atlassian.com/x/ZlZmMQ"';
        var VIDEO_LINK = 'class="collaborative-editing-banner-video-link" href="http://go.atlassian.com/collaborative-editing-video"';

        // Only show the banner if the banner DF is enabled
        if (!AJS.DarkFeatures.isEnabled("synchrony.coming-soon.banner")) {
            return;
        }

        // We don't want to show the banner on instances that already have the feature enabled
        if (AJS.DarkFeatures.isEnabled("site-wide.synchrony")) {
            return;
        }

        // We don't want to show the banner when users are not logged in
        if (!AJS.Meta.get("remote-user")) {
            return;
        }

        // Has this user already dismissed the banner?
        if (!Confluence.FeatureDiscovery || !Confluence.FeatureDiscovery.forPlugin(PLUGIN_KEY).shouldShow(FEATURE_DISCOVERY_ID)) {
            return;
        }

        var isAdmin = AJS.Meta.get("is-confluence-admin");
        var str = isAdmin ?
            AJS.I18n.getText("collab.coming-soon.banner.admin", VIDEO_LINK, BANNER_LINK) :
            AJS.I18n.getText("collab.coming-soon.banner", VIDEO_LINK, BANNER_LINK);

        $("#header").prepend(Templates.CollaborativeEditor.ComingSoon.banner({message: str}));

        AJS.trigger('analyticsEvent', {
            name: 'confluence.synchrony.banner.seen',
            data: {isAdmin: isAdmin}
        });

        $(".collaborative-editing-banner-close").click(
            function () {
                Confluence.FeatureDiscovery.forPlugin(PLUGIN_KEY).markDiscovered(FEATURE_DISCOVERY_ID);
                $(".collaborative-editing-banner").remove();
                AJS.trigger('analyticsEvent', {
                    name: 'confluence.synchrony.banner.close',
                    data: {isAdmin: isAdmin}
                });
            });

        $(".collaborative-editing-banner-doc-link").click(
            function () {
                AJS.trigger('analyticsEvent', {
                    name: 'confluence.synchrony.banner.doc-clicked',
                    data: {isAdmin: isAdmin}
                });
            }
        );

        $(".collaborative-editing-banner-video-link").click(
            function () {
                AJS.trigger('analyticsEvent', {
                    name: 'confluence.synchrony.banner.video-clicked',
                    data: {isAdmin: isAdmin}
                });
            }
        );
    });
});